// MorphDlg.cpp : implementation file
#include "stdafx.h"
#include "Morph.h"
#include "MorphDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMorphDlg::CMorphDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMorphDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMorphDlg)
	m_nBrowseVertexAll = 0;
	m_NormalCount = 0;
	m_dNormalX = 0.0;
	m_dNormalZ = 0.0;
	m_dNormalY = 0.0;
	m_VertexCount = 0;
	m_SimplexCount = 0;
	m_nCurNormal = 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_VertexCount = 0;
	m_CurVertex = 0;
	m_VertexHead = 0;
	m_VertexTail = 0;
	m_SimplexCount = 0;
	m_CurSimplex = 0;
	m_SimplexHead = 0;
	m_SimplexTail = 0;
	m_NormalCount = 1;
	m_dNormalLength = 1.0;
	m_curCorner = 0;
	m_nNormal = 0;
	m_nSelectionMode = -1;
	m_bShading = FALSE;
}

void CMorphDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMorphDlg)
	DDX_Control(pDX, IDC_KERNELCADCTRL1, m_DGKern);
	DDX_Radio(pDX, IDC_RB_BROWSE_VERTEX_ALL, m_nBrowseVertexAll);
	DDX_Text(pDX, IDC_EDIT_VERTEX_X, m_vtx.x[0]);
	DDX_Text(pDX, IDC_EDIT_VERTEX_Y, m_vtx.x[1]);
	DDX_Text(pDX, IDC_EDIT_VERTEX_Z, m_vtx.x[2]);
	DDX_Text(pDX, IDC_EDIT_NORMAL_COUNT, m_NormalCount);
	DDX_Text(pDX, IDC_EDIT_NORMAL_X, m_dNormalX);
	DDX_Text(pDX, IDC_EDIT_NORMAL_Z, m_dNormalZ);
	DDX_Text(pDX, IDC_EDIT_NORMAL_Y, m_dNormalY);
	DDX_Text(pDX, IDC_EDIT_VERTEX_COUNT, m_VertexCount);
	DDX_Text(pDX, IDC_EDIT_SIMPL_COUNT, m_SimplexCount);
	DDX_Text(pDX, IDC_EDIT_CUR_NORMAL, m_nCurNormal);
	DDX_Check(pDX, IDC_SHADING, m_bShading);
	DDX_Control(pDX, IDC_SPIN_NORMAL_COUNT, m_spinNormalCount);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMorphDlg, CDialog)
	//{{AFX_MSG_MAP(CMorphDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_BN_CLICKED(IDC_BUT_NEXT_VERT, OnNextVertex)
	ON_BN_CLICKED(IDC_BUT_PREV_VERT, OnPrevVertex)
	ON_BN_CLICKED(IDC_BUT_NEXT_SIMPL, OnNextSimplex)
	ON_BN_CLICKED(IDC_BUT_PREV_SIMPL, OnPrevSimplex)
	ON_BN_CLICKED(IDC_BUTT_VERTEX_MODIFY, OnVertexModify)
	ON_BN_CLICKED(IDC_BUTT_NORMAL_MODIFY, OnNormalModify)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_CUR_NORMAL, OnDeltaposCurNormal)
	ON_EN_KILLFOCUS(IDC_EDIT_CUR_NORMAL, OnKillfocusEditCurNormal)
	ON_BN_CLICKED(IDC_RADIO_MESH, OnRenderMesh)
	ON_BN_CLICKED(IDC_RADIO_SURFACE, OnRenderSurface)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_CUR_OBJ, OnChangeCurObject)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveas)
	ON_COMMAND(IDC_OPEN, OnFileOpen)
	ON_WM_DESTROY()
	ON_COMMAND(ID_SIMPL_DELETE, OnSimplexDelete)
	ON_COMMAND(ID_SIMPL_DIVIDE, OnSimplexDivide)
	ON_BN_CLICKED(IDC_RB_BROWSE_VERTEX_ALL, OnBrowseVertexAll)
	ON_BN_CLICKED(IDC_RB_BROWSE_VERTEX_SIMPL, OnBrowseVertexSimplex)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_NORMAL_COUNT, OnDeltaPosNormalCount)
	ON_COMMAND(ID_VERTEX_DEVETE, OnVertexDelete)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, &CMorphDlg::OnHelp)
	ON_BN_CLICKED(IDC_BUTT_SELECT_SIMPLEX, &CMorphDlg::OnPickSimplex)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_0, &CMorphDlg::OnSimplexGoToNeighbour0)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_1, &CMorphDlg::OnSimplexGoToNeighbour1)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_2, &CMorphDlg::OnSimplexGoToNeighbour2)
	ON_BN_CLICKED(IDC_BUT_STAR_PREV, &CMorphDlg::OnPrevStarSimplex)
	ON_BN_CLICKED(IDC_BUT_STAR_NEXT, &CMorphDlg::OnNextStarSimplex)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CMorphDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMorphDlg)
	ON_EVENT(CMorphDlg, IDC_KERNELCADCTRL1, 11 /* CurrentObjectChanged */, OnCurrentObjectChanged, VTS_UNKNOWN)
	//}}AFX_EVENTSINK_MAP
	ON_EVENT(CMorphDlg, IDC_KERNELCADCTRL1, DISPID_MOUSEDOWN, CMorphDlg::OnMouseDown, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
END_EVENTSINK_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMorphDlg message handlers

BOOL CMorphDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_iModel = m_DGKern.GetModelDG();

	// Get IView_DG for future mode manipulations
	m_iView = m_DGKern.GetViewDG();

	// Get IDraw_DG to visualize aux items (vertices, normals, etc)
	m_iDraw = m_iModel;

	CButton* pRadioMesh = (CButton*)GetDlgItem(IDC_RADIO_MESH);
	pRadioMesh->SetCheck(BST_CHECKED);

	// By default m_DGKern does not load any model
	// (ModelPath property is empty)
	// Create a simple thetrahedral by building its mesh

	CreateDefault();

	Init();

	// Enable SaveAs context menu item
	ENABLE_MENU(m_DGKern, eMenuCommandSaveAs, true)		// Defined in ..\Include\Misc.h

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// Update everything after model chage either in memory on start or after loading from the disk
void CMorphDlg::Init()
{
	UpdateModelInfo();
	UpdatePointVisual();
	UpdateSimplexVisual();
	UpdateNormalVisual();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMorphDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMorphDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// By default the application does not load any model
// ModelPath property is set to empty string in resources
// Construct dynamically simplest mesh consisting of four
// triangles, forming thetrahedral. See documentation for more details
//
void CMorphDlg::CreateDefault()
{
	// Remove all current
	m_iModel->RemoveAll(VARIANT_FALSE);
	// Create new mesh entity
	m_iCurObject = CreateDefaultObject();
	m_iCurObject->SetName("Thetrahedral");

	// Crete geometry by creating the mesh directly
	IMesh_DGPtr iMesh = m_iCurObject;

	// Create a thetrahedral consisting of four joined triangles
	POSN posnResult = 0;

	for( int i=0; i<4; i++)
		iMesh->AddVertex(&posnResult);// Will add a new vertex in the end of the 
	// vertex list (empty now). The vertex will have all zero 
	// coordinates by default

	// Modify coordinates of the vertexes

	// Get access to the vertex list 
	IList_DGPtr iVertexList; 
	iMesh->GetVertexList(&iVertexList);

	//Positions of corver vertexes
	POSN posVtx[4];

	// Get position of the first vertex
	POSN posVertex = 0;

	iVertexList->GetHeadPosition(&posVertex);

	// Leave the first one all zero coordinates
	posVtx[0] = posVertex;

	// Move to the next
	iVertexList->GetNext(&posVertex, nullptr);
	posVtx[1] = posVertex;
	iMesh->SetVertexPosition1(posVertex, 1, 0, 0); // On X axis

	// Move to the next
	iVertexList->GetNext(&posVertex, nullptr);
	posVtx[2] = posVertex;
	iMesh->SetVertexPosition1(posVertex, 0, 1, 0); // On Y axis

	// Move to the next
	iVertexList->GetNext(&posVertex, nullptr);
	posVtx[3] = posVertex;
	iMesh->SetVertexPosition1(posVertex, 0, 0, 1);

	// Build four triangles on them

	// Vertexes should be listed in CCW order, while looking
	// from the outside of the object

	// Set crease  angle to zero to make all edges sharp.
	// The component will take care of normals
	iMesh->AddSimplex(posVtx[0], posVtx[2], posVtx[1], 0.0, nullptr);
	iMesh->AddSimplex(posVtx[0], posVtx[3], posVtx[2], 0.0, nullptr);
	iMesh->AddSimplex(posVtx[0], posVtx[1], posVtx[3], 0.0, nullptr);
	iMesh->AddSimplex(posVtx[1], posVtx[2], posVtx[3], 0.0, nullptr);

	// This application needs a current object
	// It is done automatically during a model load
	// Do it here manually for the dynamically constructed object
	m_iCurObject = GetCurrentObject();

	if (m_iCurObject)
	{
		// Show local frame 
		IScene_DGPtr iScene = m_iView;
		iScene->ShowLocalFrame(m_iCurObject, VARIANT_TRUE);
	}

	m_DGKern.UpdateView();
}

IEntity_DGPtr CMorphDlg::CreateDefaultObject()
{
	IEntity_DGPtr iEntity = nullptr;
	m_iModel->AddNewEntity1("Mesh", &iEntity);
	return iEntity;
}

IEntity_DGPtr CMorphDlg::GetCurrentObject()
{
	if (!m_iView)
		m_iView = m_DGKern.GetViewDG();
	IScene_DGPtr iScene = m_iView;
	ISelection_DGPtr iSelection;
	iScene->GetCurrentItemSet(&iSelection);
	IArray_DGPtr iSelected;
	iSelection->GetSelectedItems(&iSelected);
	VARIANT_BOOL empty = VARIANT_TRUE;
	iSelected->IsEmpty(&empty);
	if(empty != VARIANT_FALSE)
		return IEntity_DGPtr();
	IUnknown* iUnk = nullptr;
	iSelected->GetAt(0, &iUnk);
	IEntity_DGPtr curObject(iUnk);
	return curObject;
}

void CMorphDlg::SetCurrentObject(IEntity_DGPtr iEnt)
{
	if (!m_iView)
		m_iView = m_DGKern.GetViewDG();

	IScene_DGPtr iScene = m_iView;
	ISelection_DGPtr iSelection = nullptr;
	iScene->GetCurrentItemSet(&iSelection);
	iSelection->ClearSelection();
	IObject_DGPtr iObj = iEnt;
	iSelection->SetSelected(iObj, true);
}

void CMorphDlg::UpdateModelInfo()
{
	Reset();	// Can be loading a new model. Release the surrent ones

	m_iModel = m_DGKern.GetModelDG();

	m_iCurObject = GetCurrentObject();

	if (!m_iCurObject)
	{
		m_iModel->GetEntityAt(0, &m_iCurObject);
		SetCurrentObject(m_iCurObject);
	}

	BSTR cType = nullptr;

	// SOR sections do not have mesh
	m_iCurObject->GetGeometryType(&cType);

	CString geometryType(cType);
	SysFreeString(cType);
	if (geometryType != "Mesh")
	{
		AfxMessageBox("The loaded model is not suitable for Morph sample");

		m_iCurObject = nullptr;
		// Set all like on the start. 
		m_DGKern.SetModelPath("");
		// Can look for another object, but keep it simple.
		CreateDefault();

		UpdateModelInfo();

		return;
	}

	UpdateObjectInfo();	
}

void CMorphDlg::UpdateObjectInfo()
{
	if( m_iCurObject != NULL )	// Any object selected?
	{
		m_iFrame = m_iCurObject;

		m_iMesh = m_iCurObject;

		if( !m_iMesh )
			return;		// Most likely wrong model is loaded with current object which is not a mesh section

		m_iMesh->GetVertexList(&m_iVertexList);

		m_iVertexList->GetCount(&m_VertexCount);

		m_iVertexList->GetHeadPosition(&m_VertexHead);
		m_iVertexList->GetTailPosition(&m_VertexTail);

		// Simplexes:
		m_iMesh->GetSimplexList(&m_iSimplexList);

		UpdatePositions();

		if( m_nBrowseVertexAll == 0 )
		{
			// Case browse all vertexes independently of the current simplex
			m_CurVertex = m_VertexHead;
		}
		else
			SetCurrentVertex(m_curCorner);

		UpdateVertexInfo();

		CalcModelSize();

		// Generate incidency information. Otherwise ISimplexEx_KCT. IEdge_KC and IVertexEx_KCT will not be available
		m_iMesh->Upgrade();

		UpdateNormalInfo();
	}

	UpdatePage();
}

void CMorphDlg::UpdatePositions()
{
	m_iSimplexList->GetCount(&m_SimplexCount);
			
	if( m_SimplexCount > 0 )
	{
		m_iSimplexList->GetHeadPosition(&m_SimplexHead);
		m_iSimplexList->GetTailPosition(&m_SimplexTail);
		m_CurSimplex = m_SimplexHead;
	}
	else
	{
		m_SimplexHead = 0;
		m_SimplexTail = 0;
		m_CurSimplex = 0;
	}

	UpdateSimplexVisual();
}

void CMorphDlg::SetCurrentVertex(int i)
{
	i = ( i<3 ? i : 0);

	POSN v[3];

	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	m_CurVertex = v[i];
}


void CMorphDlg::UpdateVertexInfo()
{
	if( m_CurVertex == 0 )
		return;

	// Get the current vertex coordinates
	// Expressed in local frame of the object. 
	// to make sure geometry of the object is not changed when the object 
	// is being moved
	m_iMesh->GetVertexPosition(m_CurVertex, &m_vtx);

	// The same vertex in global coordinates.
	m_vtxGlob = GetVertexGlob(m_CurVertex);

	if( m_nBrowseVertexAll == 1 )
	{
		ISimplex_DGPtr iSimplex;
		m_iMesh->GetSimplex(m_CurSimplex, &iSimplex);

		// Find out which normal belongs to the current simplex
		int nCorner = FindCorner(m_CurVertex);	

		if( nCorner < 0 )	// Did not find the corner?
		{
			nCorner = 0;
			// Case the current vertex does not belong to the
			// current simplex anymore
			// Change the current vertex to vertex 0 of the 
			// current simplex
			iSimplex->GetVertexPosition( 0, &m_CurVertex );

			// Have to do above staff again
			m_iMesh->GetVertexPosition(m_CurVertex, &m_vtx);

			m_vtxGlob = GetVertexGlob(m_CurVertex);
		}
		
		iSimplex->GetNormalIndex(nCorner, &m_nNormal);
	}

	UpdatePointVisual();

	UpdateNormalInfo();

	UpdateVertexGroup();
}


void CMorphDlg::CalcModelSize()
{
	// Get estimation of the model size to draw normals of comparable size
	IMetrics_DGPtr iMetrics = m_iModel;
	iMetrics->GetSize(&m_dNormalLength);
	m_dNormalLength *= 0.4;
}

PointDg CMorphDlg::GetVertexGlob(POSN vertex)
{
	PointDg pt;
	m_iMesh->GetVertexPosition(vertex, &pt);
	// GetVertexCoord returns pt expresed in locall coordinate axes
	m_iFrame->ToGlobal1(&pt);
	return pt;
}

// For the case of browsing inside the simplex. 
// Which corner of the current simplex is the current vertex?
int CMorphDlg::FindCorner(POSN vertex)
{
	POSN v[3];

	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	for(int i=0; i<3; i++)
	{
		if( v[i] == vertex )
			return i;
	}

	return -1;	// Did not find
}


void CMorphDlg::UpdateNormalInfo()
{
	if( m_CurVertex == 0 )
		return;	

	if( m_iMesh == NULL )
		return;

	// Note: IMeshT.GetNormal() returns only the first normal
	// Which is the only normal when the vertex is a regular one
	// (inside a smooth piece of surface).
	// When the vertex is at an edge or a corner it has several normals
	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex);

	iVertex->GetNormalCount(&m_NormalCount);

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_CUR_NORMAL);

	if( m_nBrowseVertexAll == 0 )
		pSpin->SetRange(0, m_NormalCount-1);

	m_spinNormalCount.SetRange(1, m_NormalCount);
	m_spinNormalCount.SetPos(m_NormalCount);

	UpdateCurNormal();
}

void CMorphDlg::UpdateVertexGroup()
{
	// For simplex all in loop. No head or tail. 
	bool bSimplex = m_nBrowseVertexAll == 1;

	GetDlgItem(IDC_BUT_PREV_VERT)->EnableWindow( bSimplex || m_CurVertex!=m_VertexHead );
	GetDlgItem(IDC_BUT_NEXT_VERT)->EnableWindow( bSimplex || m_CurVertex!=m_VertexTail );

	UpdateData(FALSE);
}

void CMorphDlg::UpdatePointVisual()
{
	CH(m_iDraw);

	m_iDraw->PushAttrib();	// save all attributes: color, point size, etc
	m_iPointVisual ? m_iDraw->BeginUpdate(m_iPointVisual) : m_iDraw->Begin(ePointsDG);

	// Draw a single point at the current vertex.
	m_iDraw->Color(1, 0, 0, 1);	// Set red the current color (RGB and transparency)
	m_iDraw->PointSize(8);

	// At this point the current drawing frame coinsides with the global axes
	// because we did not use IDraw.Translate, etc
	// To make it simpler and avoid drawing frame positioning
	// use global coordinates
	m_iDraw->Vertex(m_vtxGlob.x[0], m_vtxGlob.x[1], m_vtxGlob.x[2]);

	m_iPointVisual ? m_iDraw->EndUpdate() : m_iDraw->End(&m_iPointVisual);

	if (m_iPointVisual)
		m_iPointVisual->SetName("Vertex");

	m_iDraw->PopAttrib();

	m_DGKern.UpdateView();
}

void CMorphDlg::UpdateSimplexVisual()
{
	CH(m_iDraw);

	m_iDraw->PushAttrib();	// save all attributes: color, point size, etc
	m_iSimplexVisual ? m_iDraw->BeginUpdate(m_iSimplexVisual) : m_iDraw->Begin(eLineLoopDG);

	// Draw the current simplex
	if (m_CurSimplex != 0 && m_iMesh)
	{
		POSN v[3];

		m_iMesh->GetSimplexVertices(m_CurSimplex, &v[0], &v[1], &v[2]);

		m_iDraw->Color(0.7, 0.4, 1, 1);
		m_iDraw->LineWidth(3);

		for (int i = 0; i < 3; i++)
		{
			PointDg pt = GetVertexGlob(v[i]);
			m_iDraw->Vertex(pt.x[0], pt.x[1], pt.x[2]);
		}
	}

	m_iSimplexVisual ? m_iDraw->EndUpdate() : m_iDraw->End(&m_iSimplexVisual);

	if (m_iSimplexVisual)
		m_iSimplexVisual->SetName("Simplex");

	m_iDraw->PopAttrib();

	m_DGKern.UpdateView();
}

void CMorphDlg::UpdateNormalVisual()
{
	CH(m_iDraw);

	m_iDraw->PushAttrib();	// save all attributes: color, point size, etc
	m_iNormalVisual ? m_iDraw->BeginUpdate(m_iNormalVisual) : m_iDraw->Begin(eLinesDG);

	// Draw the current normal
	m_iDraw->LineWidth(2);
	m_iDraw->Color(0.4, 0.7, 0.0, 1);

	m_iDraw->Vertex(m_vtxGlob.x[0], m_vtxGlob.x[1], m_vtxGlob.x[2]);
	m_iDraw->Vertex(
		m_vtxGlob.x[0] + m_dNormalLength*m_dNormalX,
		m_vtxGlob.x[1] + m_dNormalLength*m_dNormalY,
		m_vtxGlob.x[2] + m_dNormalLength*m_dNormalZ);


	m_iNormalVisual ? m_iDraw->EndUpdate() : m_iDraw->End(&m_iNormalVisual);

	if (m_iNormalVisual)
		m_iNormalVisual->SetName("Normal");

	m_iDraw->PopAttrib();

	m_DGKern.UpdateView();
}

void CMorphDlg::UpdatePage()
{
	EnableControls();

	if( m_iCurObject == NULL )
	{
		GetDlgItem(IDC_TXT_CUR_OBJECT)->SetWindowText("No selection");
		return;
	}

	UpdateSimplexButtons();

	BSTR cObjName = nullptr;

	m_iCurObject->GetName(&cObjName);

	CString objName(cObjName);

	GetDlgItem(IDC_TXT_CUR_OBJECT)->SetWindowText(objName.IsEmpty() ? "No name" : objName);

	UpdateData(FALSE);
}


// In case there is no current object selected
// all controls except the bottom ones should
// be disabled
void CMorphDlg::EnableControls()
{
	BOOL bEnable = m_iCurObject != NULL;

	//Enable/disable all in a loop and enable 
	// bottom ones manually
	CWnd* pControl = GetWindow( GW_CHILD );

	// below casing firrst-chance exception on KC. KC is the last in tab order. So stop when reached
	while (pControl && pControl != &m_DGKern )
	{
		pControl->EnableWindow(bEnable);
		pControl = pControl->GetNextWindow(GW_HWNDNEXT);
	}

	GetDlgItem(IDC_GROUP_RENDER)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_MESH)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_SURFACE)->EnableWindow(TRUE);
	GetDlgItem(IDC_LABEL_CUR_OBJECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_TXT_CUR_OBJECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CHANGE_CUR_OBJ)->EnableWindow(TRUE);

	CButton* pRadioSurf = (CButton*)GetDlgItem(IDC_RADIO_SURFACE);
	int nCheck = pRadioSurf->GetCheck();
	GetDlgItem(IDC_SHADING)->EnableWindow( nCheck == 1 );
}


void CMorphDlg::UpdateCurNormal()
{
	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex);

	iVertex->GetNormal1(m_nCurNormal, &m_dNormalX, &m_dNormalY, &m_dNormalZ );

	UpdateNormalVisual();
}


void CMorphDlg::OnFileExit() 
{
	EndDialog(IDOK);
}

void CMorphDlg::OnNextVertex() 
{
	if( m_CurVertex == 0 )
		return;	

	if( m_nBrowseVertexAll == 0 )
		m_iVertexList->GetNext(&m_CurVertex, nullptr);
	else
	{
		if( ++m_curCorner >= 3 )
			m_curCorner = 0;	// Looping

		SetCurrentVertex( m_curCorner );
	}

	UpdateVertexInfo();
}


void CMorphDlg::OnPrevVertex() 
{
	if( m_CurVertex == 0 )
		return;	// Should not actually happen. In this case the button shuld be disabled

	if( m_nBrowseVertexAll == 0 )
		m_iVertexList->GetPrev(&m_CurVertex, nullptr);
	else
	{
		if( --m_curCorner < 0 )
			m_curCorner = 2;	// Looping

		SetCurrentVertex( m_curCorner );
	}

	UpdateVertexInfo();
}

void CMorphDlg::OnNextSimplex() 
{
	if (m_CurSimplex == 0) return;
	m_iSimplexList->GetNext(&m_CurSimplex, nullptr);
	UpdateSimplexInfo();
}

void CMorphDlg::OnPrevSimplex()
{
	if (m_CurSimplex == 0) return;
	m_iSimplexList->GetPrev(&m_CurSimplex, nullptr);
	UpdateSimplexInfo();
}

// Position of the current simplex m_CurSimplex has been modified. Update relevamt information
void CMorphDlg::UpdateSimplexInfo()
{
	UpdateSimplexButtons();

	if( m_nBrowseVertexAll == 1 )
		UpdateVertexInfo();

	UpdateSimplexVisual();
}

void CMorphDlg::UpdateSimplexButtons()
{
	GetDlgItem(IDC_BUT_NEXT_SIMPL)->EnableWindow( m_CurSimplex != m_SimplexTail );
	GetDlgItem(IDC_BUT_PREV_SIMPL)->EnableWindow( m_CurSimplex != m_SimplexHead );

	int buttons[] = {IDC_BUT_SIMPL_NEIGHBOUR_0, IDC_BUT_SIMPL_NEIGHBOUR_1, IDC_BUT_SIMPL_NEIGHBOUR_2};
	for(int i=0; i<3; i++)
	{
		ISimplex_DGPtr iSimpl = GetAdjacentSimplex(i);
		GetDlgItem( buttons[i] )->EnableWindow( iSimpl != NULL );
	}

	GetDlgItem( IDC_BUT_STAR_PREV )->EnableWindow( CanAdvanceSimplexInVertexStar(false) );
	GetDlgItem( IDC_BUT_STAR_NEXT )->EnableWindow( CanAdvanceSimplexInVertexStar(true) );
}

void CMorphDlg::OnVertexModify() 
{
	UpdateData();

	m_iMesh->SetVertexPosition(m_CurVertex, &m_vtx);

	// We are changing a low-level attribute of mesh. These are not detected automatically. Notify the software
	IGeometry_DGPtr iGeometry;
	m_iCurObject->GetGeometry(&iGeometry);
	iGeometry->SetModified();

	// Update global coords for drawing
	m_vtxGlob = GetVertexGlob(m_CurVertex);

	UpdateSimplexVisual();
	UpdatePointVisual();
	UpdateNormalVisual();
}

void CMorphDlg::OnNormalModify() 
{
	UpdateData();

	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex);

	iVertex->SetNormal1(m_nCurNormal, m_dNormalX, m_dNormalY, m_dNormalZ );

	//Mark the object as modified. Required since v5.0
	IGeometry_DGPtr iGeom;
	m_iCurObject->GetGeometry(&iGeom);
	iGeom->SetModified();

	UpdateNormalVisual();
}

void CMorphDlg::OnDeltaposCurNormal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	if(pNMUpDown->iDelta==0) return;

	m_nCurNormal += pNMUpDown->iDelta;

	if( m_nCurNormal < 0 )
	{
		m_nCurNormal = 0;
		*pResult = 1;	// Reject the change in the control
		return;
	}

	if( m_nCurNormal >= m_NormalCount )
	{
		m_nCurNormal = m_NormalCount-1;
		*pResult = 1;	// Reject the change in the control
		return;
	}

	OnCurNormalChanged();
	
	*pResult = 0;
}

void CMorphDlg::OnKillfocusEditCurNormal() 
{
	UpdateData();
	OnCurNormalChanged();
}

void CMorphDlg::OnCurNormalChanged()
{
	UpdateCurNormal();	
	UpdateData(FALSE);
}

void CMorphDlg::OnRenderMesh() 
{
	m_DGKern.SetRenderSolid(FALSE);
	UpdateObjectInfo();
	UpdatePage();
}

void CMorphDlg::OnRenderSurface() 
{
	m_DGKern.SetRenderSolid(TRUE);
	UpdateObjectInfo();
	UpdatePage();
}

void CMorphDlg::OnChangeCurObject() 
{
	// Prompt the user to select an object with the mouse
	GetDlgItem(IDC_TXT_PROMPT)->ShowWindow(TRUE);

	// Switch to render surface to see the selected object
	// (Highlighted with reddish color)
	if( !m_DGKern.GetRenderSolid())
	{
		m_DGKern.SetRenderSolid(TRUE);

		auto pRadioSurf = (CButton*)GetDlgItem(IDC_RADIO_SURFACE);
		pRadioSurf->SetCheck(BST_CHECKED);
		auto pRadioMesh = (CButton*)GetDlgItem(IDC_RADIO_MESH);
		pRadioMesh->SetCheck(BST_UNCHECKED);
	}

	// Change view mode to modal to enable mouse object selection
	m_iView->SetViewMode(ViewMode_DG::eViewModeDgModify);
}

void CMorphDlg::OnCurrentObjectChanged(LPUNKNOWN pIEntCur)
{
	// Hide the prompt
	GetDlgItem(IDC_TXT_PROMPT)->ShowWindow(FALSE);

	// pIEntCur = NULL is a valid case, which means that the user
	// clicked in 3D outside of any objects
	if (!pIEntCur)
	{
		//User clicked outside any objects
		m_iCurObject = nullptr;
		UpdatePage();
		AfxMessageBox("Nothing selected");
		return;
	}

	// IEntity_DG of newly selected object is passed via parameter
	IEntity_DGPtr iNewObject = pIEntCur;
	
	if (m_iCurObject == iNewObject)	// The same object selected?
		return;

	std::string type;

	// SOR sections do not have mesh
	if (iNewObject)
		type = UtilDg::GetGeometryType(iNewObject);

	if( iNewObject == NULL || type != "Mesh" )
	{
		if( iNewObject != NULL )
			AfxMessageBox("The selected object has type which does not have mesh\nPlease select another object");
		else
			AfxMessageBox("Nothing selected");

		// Restore current object in the model
		IScene_DGPtr iScene = m_iView;
		ISelection_DGPtr iSelection;
		iScene->GetCurrentItemSet(&iSelection);
		iSelection->ClearSelection();
		IObject_DGPtr iObj = m_iCurObject;
		iSelection->SetSelected(iObj, true);
	}
	else
	{
		m_iCurObject = iNewObject;
		UpdateObjectInfo();
	}

	// Switch off modal mode right away to prevent moving objects
	// and enable viewing rotations, etc.
	m_iView->SetViewMode(ViewMode_DG::eViewModeDgView);
}

void CMorphDlg::OnFileSaveas() 
{
	CString strModelPath = m_DGKern.GetModelPath();

	CFileDialog dlg( FALSE, "mdg", strModelPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			"Model files v6|*.mdg|Model files v5|*.glm|OBJ Wavefront (*.obj)|*.obj|STL Files|*.stl|VRML Files|*.wrl;*.vrml||");

	if(dlg.DoModal() != IDOK)
		return;

	strModelPath = dlg.GetPathName();

	CString strExt = strModelPath.Right(strModelPath.ReverseFind('.'));
	strExt.MakeLower();

	bool bUseDefault = false;

	if (!bUseDefault && strExt == ".stl")
	{
		// Set any custom options
		IObjectGenerator_DGPtr gen = m_iModel;
		ISTLDataContext_DGPtr iSTLOptions;
		gen->Create("ISTLDataContext_DG", (IUnknown**)&iSTLOptions);
		IDataContext_DGPtr iBaseOptions = iSTLOptions;
		iBaseOptions->SetVerbose(VARIANT_FALSE);	// Do not show any messages from component
		iSTLOptions->SetBinary(VARIANT_FALSE);    // Save as ASCII stl only because it is tiny
		IDictionary_DGPtr options;
		gen->Create("IDictionary_DG", (IUnknown**)&options);
		options->SetInterface("IDataContext_DG", iBaseOptions);      // Save() will detect that the actual type
																	// of options is ISTLDataContext_DG
		VARIANT_BOOL success;
		m_iModel->SaveEx(strModelPath.GetBuffer(), options, &success);
	}
	else
		m_DGKern.SaveAs(strModelPath);
}


void CMorphDlg::OnFileOpen() 
{
	CString strModelPath = m_DGKern.GetModelPath();

	CFileDialog dlg( TRUE, "mdg", strModelPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			"Model files v6|*.mdg|Model files v5|*.glm|OBJ Wavefront (*.obj)|*.obj|STL Files|*.stl|VRML Files|*.wrl;*.vrml||");

	if(dlg.DoModal() != IDOK)
		return;

	m_bShadingDataOK = false;

	strModelPath = dlg.GetPathName();	

	m_DGKern.SetModelPath(strModelPath);

	m_nBrowseVertexAll = 0;

	Init();
}

void CMorphDlg::OnDestroy() 
{
	Reset();
	CDialog::OnDestroy();
}

// Reset all, apart from ones which do not depend on model change
void CMorphDlg::Reset()
{
	m_CurSimplex = 0;

	m_iCurObject = nullptr;
	m_iFrame = nullptr;
	m_iMesh = nullptr;
	m_iVertexList = nullptr;
	m_iSimplexList = nullptr;
	m_iPointVisual = nullptr;
	m_iSimplexVisual = nullptr;
	m_iNormalVisual = nullptr;
}

void CMorphDlg::OnSimplexDelete() 
{
	DeleteCurSimplex();
}

void CMorphDlg::OnSimplexDivide() 
{
	if( m_CurSimplex == 0 )
		return;

	// Add a new vertex in the middle of the triangle
	POSN posnVtx = 0;
	m_iMesh->AddVertex(&posnVtx);

	POSN v[3];
	// Calculate point in the middle as an average
	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	double corner[3][3];
	double vtx[3];

	vtx[0] = vtx[1] = vtx[2] = 0;

	for( int i=0; i<3; i++)
	{
		m_iMesh->GetVertexPosition1(v[i], corner[i], corner[i]+1, corner[i]+2);

		for( int k=0; k<3; k++)
			vtx[k] += corner[i][k]/3.0;
	}

	m_iMesh->SetVertexPosition1( posnVtx, vtx[0], vtx[1], vtx[2] );

	// Need to set correct normal
	double n[3];
	ISimplex_DGPtr iSimplex;
	m_iMesh->GetSimplex(m_CurSimplex, &iSimplex);

	iSimplex->GetFaceNormal1(n, n+1, n+2);

	m_iMesh->SetNormal1(posnVtx, n[0], n[1], n[2]); //No sharp edges in the 
													// middle so the only normal in the vertex

	DeleteCurSimplex();

	// Replace the simplex
	m_iMesh->AddSimplex( v[0], v[1], posnVtx, 90.0, nullptr);
	m_iMesh->AddSimplex( v[1], v[2], posnVtx, 90.0, nullptr);
	m_iMesh->AddSimplex( v[2], v[0], posnVtx, 90.0, nullptr);

	// Need to update all intermediate members
	UpdateModelInfo();
}

void CMorphDlg::DeleteCurSimplex()
{
	if( m_CurSimplex == 0 ) return;

	m_iMesh->RemoveSimplex(m_CurSimplex);

	UpdatePositions();

	UpdateSimplexButtons();

	m_DGKern.UpdateSurface();

	UpdatePage();

	m_DGKern.UpdateView();
}

void CMorphDlg::OnBrowseVertexAll() 
{
	m_nBrowseVertexAll = 0;
}

void CMorphDlg::OnBrowseVertexSimplex() 
{
	m_nBrowseVertexAll = 1;
}

void CMorphDlg::OnDeltaPosNormalCount(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	if(pNMUpDown->iDelta<=0)	
	{
		// Block Reduction - can crush the application. Need to take care about references in adjacent simplexes first
		*pResult = 1;	// Signal that the change has been refused
		return;
	}
	*pResult = 0;

	int count = pNMUpDown->iPos + pNMUpDown->iDelta;

	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex);

	iVertex->SetNormalCount(count);

	UpdateNormalInfo();
	UpdateData(FALSE);
}

void CMorphDlg::OnVertexDelete()
{
	UpdateData();

	if( m_CurVertex == 0 ) return;

	if( AfxMessageBox("Delete Vertex operation should only be preformed\nto remove remaning isolated vertexes after\ndeletion of simplexes. Press Ok to proceed", MB_OKCANCEL ) != IDOK )
		return;

	// Do the deletion
	m_iMesh->RemoveVertex(m_CurVertex);

	UpdatePositions();

	UpdatePage();
	m_DGKern.UpdateView();
}

void CMorphDlg::OnHelp()
{
	// DIHelp declaration is included via DIKernCAD.h in StdAfx.h
	DIHelp help("Samples/Morph.aspx");
}

void CMorphDlg::SetSelectionMode(int mode)
{
	m_nSelectionMode = mode;
	GetDlgItem(IDC_MESSAGE_CLICK_SIMPLEX)->ShowWindow( mode >= 0 ? SW_SHOW : SW_HIDE );
	UpdateData(FALSE);	// Show / hide the IDC_MESSAGE_CLICK_SIMPLEX hint
}

void CMorphDlg::OnPickSimplex()
{
	SetSelectionMode(2);
}

void CMorphDlg::OnMouseDown(short Button, short Shift, long x, long y)
{
	if( m_nSelectionMode == 2 )
	{
		IPick_DGPtr iPick = m_iView;

		ISurfacePoint_DGPtr iSurfPoint;
		iPick->GetSurfacePointAt( x, y, &iSurfPoint );

		IEntity_DGPtr iEnt;
		iSurfPoint->GetEntity(&iEnt);
		BSTR bstrGeomType = SysAllocString(L"");
		iEnt->GetGeometryType(&bstrGeomType);
		CString sGeomType = bstrGeomType;
		ASSERT(sGeomType == "Mesh");   // See Pick sample for handling BRep geometry

		EDim_DG nDim;
		iSurfPoint->GetElementDimension(&nDim);
		if (nDim == 2)
		{
			IMeshPoint_DGPtr iMeshPoint = iSurfPoint;

			POSN position = 0;
			iMeshPoint->GetSimplexListPosition(&position);

			if (position != 0)
			{
				m_CurSimplex = position;
				UpdateSimplexInfo();
			}

			SetSelectionMode(-1);

			TestSurfacePoint(iSurfPoint);    // Test/demo an alternative way
		}

		SysFreeString(bstrGeomType);
	}
}

void CMorphDlg::TestSurfacePoint(ISurfacePoint_DGPtr iSurfPoint)
{
	IEntity_DGPtr iEntity;
	iSurfPoint->GetEntity(&iEntity);

	EDim_DG dim;
	iSurfPoint->GetElementDimension(&dim);

	double xx, yy, zz;
	IUnknown* iUnk = nullptr;
	if (dim == 0)
	{
		iSurfPoint->GetElement(&iUnk);
		IVertex_DGPtr iVertex(iUnk);
		iVertex->GetPosition1(&xx, &yy, &zz);
	}
	else if (dim == 1)
	{
		iSurfPoint->GetElement(&iUnk);
		IVertexSegment_DGPtr iEdge(iUnk);
		IVertex_DGPtr iVertex;
		iEdge->GetEnd(0, &iVertex);
		iVertex->GetPosition1(&xx, &yy, &zz);
	}
	else if (dim == 2)
	{
		iSurfPoint->GetElement(&iUnk);
		ISimplex_DGPtr iSimplex(iUnk);
		POSN pos = 0;
		iSimplex->GetVertexPosition(0, &pos);
		IMesh_DGPtr iMesh = iEntity;
		iMesh->GetVertexPosition1(pos, &xx, &yy, &zz);
	}
}

void CMorphDlg::OnSimplexGoToNeighbour0()
{
	GoToAdjacentSimplex(0);
}

void CMorphDlg::OnSimplexGoToNeighbour1()
{
	GoToAdjacentSimplex(1);
}

void CMorphDlg::OnSimplexGoToNeighbour2()
{
	GoToAdjacentSimplex(2);
}

ISimplex_DGPtr CMorphDlg::GetAdjacentSimplex(int edge)
{
	CHN(m_CurSimplex);
	ISimplex_DGPtr iSimplex;
	m_iMesh->GetSimplex(m_CurSimplex, &iSimplex);

	ISimplex_DGPtr iSimplNeighBour;
	iSimplex->GetAdjacentSimplex(edge, &iSimplNeighBour);
	return 	iSimplNeighBour;
}

void CMorphDlg::GoToAdjacentSimplex(int edge)
{
	ISimplex_DGPtr iSimplNeighBour = GetAdjacentSimplex(edge);

	CH(iSimplNeighBour);		// Normally not an error. Happens when the edge is edge of the mesh
	// But in this application this means that the buttons where not disabled correctly

	m_iMesh->GetSimplexListPosition(iSimplNeighBour, &m_CurSimplex);

	UpdateSimplexInfo();
}

void CMorphDlg::OnPrevStarSimplex()
{
	AdvanceCurrentSimplexInVertexStar(false);
}

// If the current simplex does not belong to the start of the current vertex. Simplex 0 of the star
// is made current independently of bForward
void CMorphDlg::AdvanceCurrentSimplexInVertexStar(bool bForward)
{
	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex );

	// Get index of the the current simplex in star of the vertex
	ISimplex_DGPtr iSimplex;
	m_iMesh->GetSimplex(m_CurSimplex, &iSimplex);

	int index = -1;
	iVertex->FindStarSimplex(iSimplex, &index );		// index is negative if did not find

	int indexNew = 0;	//If index < 0 assume the simplex was not in the star. Take th efist simplex

	if( index >= 0 )
	{
		int simplexCount = 0;
		iVertex->GetStarElementCount(eMeshElemSimplex, &simplexCount);

		VARIANT_BOOL interior;
		iVertex->IsInteriorVertex(&interior);

		if( interior == VARIANT_FALSE )
		{
			// Case the vertex on edge of the mesh simplexes 0 and simplexCount-1 are on the edge of the mesh. Can not step beyond
			if( bForward && index >= simplexCount-1 || (index==0 && !bForward) )
				return;
		}

		// Get next cyclic
		if(bForward)
			indexNew = (index+1) % simplexCount;
		else
			indexNew = ( index==0 ? simplexCount-1 : index-1 );
	}

	ISimplex_DGPtr iSimplexExNew;
	iVertex->GetStarSimplex( indexNew, &iSimplexExNew);

	m_iMesh->GetSimplexListPosition(iSimplexExNew, &m_CurSimplex);

	UpdateSimplexInfo();
}

// Can do AdvanceCurrentSimplexInVertexStar(bool bForward) ?
bool CMorphDlg::CanAdvanceSimplexInVertexStar(bool bForward)
{
	IVertex_DGPtr iVertex;
	m_iMesh->GetVertex(m_CurVertex, &iVertex );

	// Get index of the the current simplex in star of the vertex
	ISimplex_DGPtr iSimplex;
	m_iMesh->GetSimplex(m_CurSimplex, &iSimplex);

	int index = -1;
	iVertex->FindStarSimplex(iSimplex, &index );		// index is negative if did not find

	bool bOK = true;

	if( index >= 0 )
	{
		int simplexCount = 0;
		iVertex->GetStarElementCount(eMeshElemSimplex, &simplexCount);

		VARIANT_BOOL interior;
		iVertex->IsInteriorVertex(&interior);

		if( interior == VARIANT_FALSE )
		{
			// Case the vertex on edge of the mesh simplexes 0 and simplexCount-1 are on the edge of the mesh. Can not step beyond
			if( bForward && index >= simplexCount-1 || (index==0 && !bForward) )
				bOK = false;
		}
	}
	return bOK;
}

void CMorphDlg::OnNextStarSimplex()
{
	AdvanceCurrentSimplexInVertexStar(true);
}

